bug-bash
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: process substitution error handling


From: Oğuz
Subject: Re: process substitution error handling
Date: Thu, 6 Aug 2020 14:15:43 +0300

6 Ağustos 2020 Perşembe tarihinde Jason A. Donenfeld <Jason@zx2c4.com>
yazdı:

> Hi,
>
> It may be a surprise to some that this code here winds up printing
> "done", always:
>
> $ cat a.bash
> set -e -o pipefail
> while read -r line; do
>        echo "$line"
> done < <(echo 1; sleep 1; echo 2; sleep 1; false; exit 1)
> sleep 1
> echo done
>
> $ bash a.bash
> 1
> 2
> done
>
> The reason for this is that process substitution right now does not
> propagate errors. It's sort of possible to almost make this better
> with `|| kill $$` or some variant, and trap handlers, but that's very
> clunky and fraught with its own problems.
>
> Therefore, I propose a `set -o substfail` option for the upcoming bash
> 5.1, which would cause process substitution to propagate its errors
> upwards, even if done asynchronously.
>
>
    set -e o substfail
    : <(sleep 10; exit 1)
    foo

Say that `foo' is a command that takes longer than ten seconds to complete,
how would you expect the shell to behave here? Should it interrupt `foo' or
wait for its termination and exit then? Or do something else?


> Chet - thoughts?
>
> It'd certainly make a lot of my scripts more reliable.
>
> Jason
>
>

-- 
Oğuz


reply via email to

[Prev in Thread] Current Thread [Next in Thread]